package discRack.presentation.dpanels;

import discRack.presentation.delements.*;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Creates panel with JLabel and JTextField.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class DTextPanel extends DPanel {

   public DTextPanel (DSimpleElement myOwner,boolean isPasswordField) {

      super(myOwner,3,"",false,false);

      JLabel jl=new JLabel(myOwner.toName()+": ");
      jl.setAlignmentX(Component.LEFT_ALIGNMENT);
      jl.setAlignmentY(Component.TOP_ALIGNMENT);
      jl.setHorizontalAlignment(SwingConstants.RIGHT);

      JTextField jtf;
      if (isPasswordField) {
         jtf=new JPasswordField();
      } else {
         jtf=new JTextField();
      }
      jtf.setText(myOwner.toValue().toString());
      jtf.setAlignmentX(Component.LEFT_ALIGNMENT);
      jtf.setAlignmentY(Component.TOP_ALIGNMENT);
      jtf.setMinimumSize(new Dimension(textFieldDimension));
      jtf.setMaximumSize(new Dimension(textFieldDimension));
      jtf.setPreferredSize(new Dimension(textFieldDimension));

      jtf.setEnabled(!myOwner.isReadOnly());

      Dimension minSize = new Dimension(5, 10);
      Dimension prefSize = new Dimension(100, 10);
      Dimension maxSize = new Dimension(Short.MAX_VALUE,10);

      add(Box.createHorizontalGlue());
      add(jl);
      add(jtf);

   }

   public boolean checkRequired () {
      if (isEmpty() && getOwner().isRequired() && !getOwner().isReadOnly()) {
         DPanel.defaultErrorMessage(this.getWindow(),((JLabel)getComponent(1)).getText());
         ((JTextField)getComponent(2)).requestFocus();
         return false;
      }
      return true;
   }

   public boolean isEmpty () {
      return getText().trim().equals("");
   }

   public void setElements () {
      getOwner().setValue(getText());
   }

   public String getText () {
      return ((JTextField)getComponent(2)).getText();
   }

}
